# coding=UTF-8
"""
This will return a list of Metric objects, each of which can return a line to write out.
"""
from __future__ import print_function, absolute_import, division
import six
import logging

logger = logging.getLogger(__name__)


def setup_metrics():
    """
    Return a list of callable/0 that return generators with lines.
    
    Called once per start
    """
    from circle.metrics.devices_online import device_status_metric
    from circle.metrics.sms_sent import oob_sent
    from circle.metrics.alarms import get_alarms

    return [oob_sent, device_status_metric, get_alarms]

