# coding=UTF-8
from __future__ import print_function, absolute_import, division
import six
from collections import defaultdict
import logging
from sai.basic import Cassandra, Configuration2


def device_status_metric():
    with Cassandra.cursor() as cur:
        p = cur.execute('SELECT node, online FROM s4obj.devices')

    status = {
        0: defaultdict(lambda: 0),  # offline
        1: defaultdict(lambda: 0)   # online
    }
    for node, online in p:
        status[1 if online else 0][node] += 1

    for status, stat in status.iteritems():
        for node, count in stat.iteritems():
            yield u'smok4_device_status{node="%s", online="%s"} %s' % (node, status, count)

    for node in Configuration2.get_device_nodes():

        dev_status = defaultdict(lambda: defaultdict(lambda: 0))
        han_status = defaultdict(lambda: defaultdict(lambda: 0))

        with Cassandra.cursor() as cur:
            p = cur.execute('SELECT online, handler_online, device_id, master_controller FROM sfcore.devices_on_nodes WHERE node=%s', (node, ))

        for online, han_online, device_id, master_controller in p:

            is_mc = int(device_id == master_controller)

            dev_status[1 if online else 0][is_mc] += 1
            han_status[1 if han_online else 0][is_mc] += 1

        for st in (0, 1):
            for is_mc in (0, 1):
                yield u'smok4_thrall_online_status{node="%s", online="%s", master_controller="%s"} %s' % (node, st, is_mc, dev_status[st][is_mc])
                yield u'smok4_thrall_handler_status{node="%s", online="%s", master_controller="%s"} %s' % (node, st, is_mc, han_status[st][is_mc])
