# coding=UTF-8
from __future__ import print_function, absolute_import, division
import signal, os, socket
from sai.moves.satella1 import hang_until_sig
from sai.basic import SAIContext
from circle.serve import start_serving_thread


if __name__ == '__main__':
    with SAIContext('circle', intercept_exceptions=False):

        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)

        bindat = (
            os.environ.get('SMOK4_CIRCLE_BINDADDR', '0.0.0.0'),
            int(os.environ.get('SMOK4_CIRCLE_BINDPORT', '7998'))
        )

        s.bind(bindat)
        s.listen(0)
        s.shutdown(socket.SHUT_RDWR)
        s.close()


        start_serving_thread(bindat)

        hang_until_sig(extra_signals=[signal.SIGQUIT, signal.SIGCONT])

